diff -r -u squid-2.6.STABLE13/src/htcp.c new-STABLE13/src/htcp.c
--- squid-2.6.STABLE13/src/htcp.c	Sat Nov  4 23:14:07 2006
+++ new-STABLE13/src/htcp.c	Sun May 13 00:59:37 2007
@@ -176,10 +176,12 @@
 static u_num32 msg_id_counter = 0;
 static int htcpInSocket = -1;
 static int htcpOutSocket = -1;
+static int htcpInSocket6 = -1;
+static int htcpOutSocket6 = -1;
 #define N_QUERIED_KEYS 8192
 static u_num32 queried_id[N_QUERIED_KEYS];
 static cache_key queried_keys[N_QUERIED_KEYS][MD5_DIGEST_CHARS];
-static struct sockaddr_in queried_addr[N_QUERIED_KEYS];
+static struct sockaddr_storage queried_addr[N_QUERIED_KEYS];
 static MemPool *htcpSpecifierPool = NULL;
 static MemPool *htcpDetailPool = NULL;
 
@@ -195,17 +197,17 @@
 static ssize_t htcpBuildTstOpData(char *buf, size_t buflen, htcpStuff * stuff);
 static void htcpFreeSpecifier(htcpSpecifier * s);
 static void htcpFreeDetail(htcpDetail * s);
-static void htcpHandle(char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleData(char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleMon(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleNop(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleSet(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleTst(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
+static void htcpHandle(char *buf, int sz, struct sockaddr *from);
+static void htcpHandleData(char *buf, int sz, struct sockaddr *from);
+static void htcpHandleMon(htcpDataHeader *, char *buf, int sz, struct sockaddr *from);
+static void htcpHandleNop(htcpDataHeader *, char *buf, int sz, struct sockaddr *from);
+static void htcpHandleSet(htcpDataHeader *, char *buf, int sz, struct sockaddr *from);
+static void htcpHandleTst(htcpDataHeader *, char *buf, int sz, struct sockaddr *from);
 static void htcpRecv(int fd, void *data);
-static void htcpSend(const char *buf, int len, struct sockaddr_in *to);
-static void htcpTstReply(htcpDataHeader *, StoreEntry *, htcpSpecifier *, struct sockaddr_in *);
-static void htcpHandleTstRequest(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleTstResponse(htcpDataHeader *, char *, int, struct sockaddr_in *);
+static void htcpSend(const char *buf, int len, struct sockaddr *to);
+static void htcpTstReply(htcpDataHeader *, StoreEntry *, htcpSpecifier *, struct sockaddr *);
+static void htcpHandleTstRequest(htcpDataHeader *, char *buf, int sz, struct sockaddr *from);
+static void htcpHandleTstResponse(htcpDataHeader *, char *, int, struct sockaddr *);
 static StoreEntry *htcpCheckHit(const htcpSpecifier *);
 
 static int old_squid_format = 0;
@@ -436,15 +438,18 @@
 }
 
 static void
-htcpSend(const char *buf, int len, struct sockaddr_in *to)
+htcpSend(const char *buf, int len, struct sockaddr *to)
 {
     int x;
     debug(31, 3) ("htcpSend: %s/%d\n",
-	inet_ntoa(to->sin_addr), (int) ntohs(to->sin_port));
+	sockaddr_ntoa(to), (int) (to->sa_family == AF_INET6) ?
+		ntohs(((struct sockaddr_in6 *)to)->sin6_port) :
+		ntohs(((struct sockaddr_in *)to)->sin_port)
+		);
     htcpHexdump("htcpSend", buf, len);
     x = comm_udp_sendto(htcpOutSocket,
 	to,
-	sizeof(struct sockaddr_in),
+	sizeof(struct sockaddr_storage),
 	buf,
 	len);
     if (x < 0)
@@ -624,18 +629,27 @@
 }
 
 static int
-htcpAccessCheck(acl_access * acl, htcpSpecifier * s, struct sockaddr_in *from)
+htcpAccessCheck(acl_access * acl, htcpSpecifier * s, struct sockaddr *from)
 {
     aclCheck_t checklist;
+    struct sockaddr_storage no_addr6;
+
+    safe_inet_addr("ffff:ffff:ffff:ffff:fffff:ffff:ffff:ffff", &no_addr6);
     memset(&checklist, '\0', sizeof(checklist));
-    checklist.src_addr = from->sin_addr;
-    checklist.my_addr = no_addr;
+    xmemcpy(&checklist.src_addr, from, sizeof(struct sockaddr_storage));
+    if (from->sa_family == AF_INET) {
+	((struct sockaddr *)&checklist.my_addr)->sa_family = AF_INET;
+	((struct sockaddr_in *)&checklist.my_addr)->sin_addr = no_addr;
+    }
+    else {
+	xmemcpy(&checklist.my_addr, &no_addr6, sizeof(struct sockaddr_storage));
+    }
     checklist.request = s->request;
     return aclCheckFast(acl, &checklist);
 }
 
 static void
-htcpTstReply(htcpDataHeader * dhdr, StoreEntry * e, htcpSpecifier * spec, struct sockaddr_in *from)
+htcpTstReply(htcpDataHeader * dhdr, StoreEntry * e, htcpSpecifier * spec, struct sockaddr *from)
 {
     htcpStuff stuff;
     static char pkt[8192];
@@ -707,7 +721,7 @@
 }
 
 static void
-htcpClrReply(htcpDataHeader * dhdr, int purgeSucceeded, struct sockaddr_in *from)
+htcpClrReply(htcpDataHeader * dhdr, int purgeSucceeded, struct sockaddr *from)
 {
     htcpStuff stuff;
     static char pkt[8192];
@@ -733,7 +747,7 @@
 }
 
 static void
-htcpHandleNop(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleNop(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr *from)
 {
     debug(31, 3) ("htcpHandleNop: Unimplemented\n");
 }
@@ -815,7 +829,7 @@
 }
 
 static void
-htcpHandleTst(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleTst(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr *from)
 {
     debug(31, 3) ("htcpHandleTst: sz = %d\n", (int) sz);
     if (hdr->RR == RR_REQUEST)
@@ -825,26 +839,31 @@
 }
 
 static void
-htcpHandleTstResponse(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleTstResponse(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr *from)
 {
     htcpReplyData htcpReply;
     cache_key *key = NULL;
-    struct sockaddr_in *peer;
+    struct sockaddr_storage *peer;
     htcpDetail *d = NULL;
     char *t;
 
     if (queried_id[hdr->msg_id % N_QUERIED_KEYS] != hdr->msg_id) {
-	debug(31, 2) ("htcpHandleTstResponse: No matching query id '%d' (expected %d) from '%s'\n", hdr->msg_id, queried_id[hdr->msg_id % N_QUERIED_KEYS], inet_ntoa(from->sin_addr));
+	debug(31, 2) ("htcpHandleTstResponse: No matching query id '%d' (expected %d) from '%s'\n", hdr->msg_id, queried_id[hdr->msg_id % N_QUERIED_KEYS], sockaddr_ntoa(from));
 	return;
     }
     key = queried_keys[hdr->msg_id % N_QUERIED_KEYS];
     if (!key) {
-	debug(31, 1) ("htcpHandleTstResponse: No query key for response id '%d' from '%s'\n", hdr->msg_id, inet_ntoa(from->sin_addr));
+	debug(31, 1) ("htcpHandleTstResponse: No query key for response id '%d' from '%s'\n", hdr->msg_id, sockaddr_ntoa(from));
 	return;
     }
     peer = &queried_addr[hdr->msg_id % N_QUERIED_KEYS];
-    if (peer->sin_addr.s_addr != from->sin_addr.s_addr || peer->sin_port != from->sin_port) {
-	debug(31, 1) ("htcpHandleTstResponse: Unexpected response source %s\n", inet_ntoa(from->sin_addr));
+    if ((peer->ss_family != from->sa_family) ||
+	(peer->ss_family == AF_INET6 &&
+	    (!memcmp(&((struct sockaddr_in6 *)peer)->sin6_addr, &((struct sockaddr_in6 *)from)->sin6_addr, sizeof(struct in6_addr)) || ((struct sockaddr_in6 *)peer)->sin6_port != ((struct sockaddr_in6 *)from)->sin6_port)) ||
+	(peer->ss_family == AF_INET &&
+	    (!memcmp(&((struct sockaddr_in *)peer)->sin_addr, &((struct sockaddr_in6 *)from)->sin6_addr, sizeof(struct in_addr)) || ((struct sockaddr_in6 *)peer)->sin6_port != ((struct sockaddr_in6 *)from)->sin6_port)) ) {
+/*    if (peer->sin_addr.s_addr != from->sin_addr.s_addr || peer->sin_port != from->sin_port) {*/
+	debug(31, 1) ("htcpHandleTstResponse: Unexpected response source %s\n", sockaddr_ntoa(from));
 	return;
     }
     if (hdr->F1 == 1) {
@@ -880,7 +899,7 @@
 }
 
 static void
-htcpHandleTstRequest(htcpDataHeader * dhdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleTstRequest(htcpDataHeader * dhdr, char *buf, int sz, struct sockaddr *from)
 {
     /* buf should be a SPECIFIER */
     htcpSpecifier *s;
@@ -919,19 +938,19 @@
 }
 
 static void
-htcpHandleMon(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleMon(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr *from)
 {
     debug(31, 3) ("htcpHandleMon: Unimplemented\n");
 }
 
 static void
-htcpHandleSet(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleSet(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr *from)
 {
     debug(31, 3) ("htcpHandleSet: Unimplemented\n");
 }
 
 static void
-htcpHandleClr(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleClr(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr *from)
 {
     htcpSpecifier *s;
     /* buf[0/1] is reserved and reason */
@@ -979,7 +998,7 @@
 }
 
 static void
-htcpHandleData(char *buf, int sz, struct sockaddr_in *from)
+htcpHandleData(char *buf, int sz, struct sockaddr *from)
 {
     htcpDataHeader hdr;
     if (sz < sizeof(htcpDataHeader)) {
@@ -1005,7 +1024,7 @@
     debug(31, 3) ("htcpHandleData: length = %d\n", (int) hdr.length);
     if (hdr.opcode >= HTCP_END) {
 	debug(31, 1) ("htcpHandleData: client %s, opcode %d out of range\n",
-	    inet_ntoa(from->sin_addr),
+	    sockaddr_ntoa(from),
 	    (int) hdr.opcode);
 	return;
     }
@@ -1050,7 +1069,7 @@
 }
 
 static void
-htcpHandle(char *buf, int sz, struct sockaddr_in *from)
+htcpHandle(char *buf, int sz, struct sockaddr *from)
 {
     htcpHeader htcpHdr;
     if (sz < sizeof(htcpHeader)) {
@@ -1070,13 +1089,17 @@
     if (sz != htcpHdr.length) {
 	debug(31, 1) ("htcpHandle: sz/%d != htcpHdr.length/%d from %s:%d\n",
 	    sz, htcpHdr.length,
-	    inet_ntoa(from->sin_addr), (int) ntohs(from->sin_port));
+	    sockaddr_ntoa(from), (int) from->sa_family == AF_INET6 ?
+		ntohs(((struct sockaddr_in6 *)from)->sin6_port) :
+		ntohs(((struct sockaddr_in *)from)->sin_port) );
 	return;
     }
     if (htcpHdr.major != 0) {
 	debug(31, 1) ("htcpHandle: Unknown major version %d from %s:%d\n",
 	    htcpHdr.major,
-	    inet_ntoa(from->sin_addr), (int) ntohs(from->sin_port));
+	    sockaddr_ntoa(from), (int) from->sa_family == AF_INET6 ?
+		ntohs(((struct sockaddr_in6 *)from)->sin6_port) :
+		ntohs(((struct sockaddr_in *)from)->sin_port) );
 	return;
     }
     buf += sizeof(htcpHeader);
@@ -1089,14 +1112,17 @@
 {
     static char buf[8192];
     int len;
-    static struct sockaddr_in from;
-    socklen_t flen = sizeof(struct sockaddr_in);
+    static struct sockaddr_storage from;
+    socklen_t flen = sizeof(struct sockaddr_storage);
     memset(&from, '\0', flen);
     statCounter.syscalls.sock.recvfroms++;
     /* Receive up to 8191 bytes, leaving room for a null */
     len = recvfrom(fd, buf, sizeof(buf) - 1, 0, (struct sockaddr *) &from, &flen);
     debug(31, 3) ("htcpRecv: FD %d, %d bytes from %s:%d\n",
-	fd, len, inet_ntoa(from.sin_addr), ntohs(from.sin_port));
+	fd, len, 
+	    sockaddr_ntoa(&from), (int) from.ss_family == AF_INET6 ?
+		ntohs(((struct sockaddr_in6 *)&from)->sin6_port) :
+		ntohs(((struct sockaddr_in *)&from)->sin_port) );
     if (len)
 	statCounter.htcp.pkts_recv++;
     htcpHandle(buf, len, &from);
@@ -1112,29 +1138,47 @@
 void
 htcpInit(void)
 {
+    u_short port;
+    struct sockaddr_storage addr;
+    struct sockaddr_storage xaddr;
+
     if (Config.Port.htcp <= 0) {
 	debug(31, 1) ("HTCP Disabled.\n");
 	return;
     }
     enter_suid();
+    xmemcpy(&addr, &Config.Addrs.udp_incoming, sizeof(addr));
+    ((struct sockaddr_in *)&addr)->sin_port = htons(Config.Port.htcp);
     htcpInSocket = comm_open(SOCK_DGRAM,
 	IPPROTO_UDP,
-	Config.Addrs.udp_incoming,
-	Config.Port.htcp,
+	&addr,
 	COMM_NONBLOCKING,
 	"HTCP Socket");
+    xmemcpy(&addr, &Config.Addrs.udp6_incoming, sizeof(addr));
+    ((struct sockaddr_in6 *)&addr)->sin6_port = htons(Config.Port.htcp);
+    htcpInSocket6 = comm_open(SOCK_DGRAM,
+	IPPROTO_UDP,
+	&addr,
+	COMM_NONBLOCKING,
+	"HTCP Socket v6");
     leave_suid();
     if (htcpInSocket < 0)
 	fatal("Cannot open HTCP Socket");
     commSetSelect(htcpInSocket, COMM_SELECT_READ, htcpRecv, NULL, 0);
     debug(31, 1) ("Accepting HTCP messages on port %d, FD %d.\n",
 	(int) Config.Port.htcp, htcpInSocket);
-    if (Config.Addrs.udp_outgoing.s_addr != no_addr.s_addr) {
+    if (htcpInSocket6 < 0)
+	fatal("Cannot open HTCP Socket v6");
+    commSetSelect(htcpInSocket6, COMM_SELECT_READ, htcpRecv, NULL, 0);
+    debug(31, 1) ("Accepting HTCP messages v6 on port %d, FD %d.\n",
+	(int) Config.Port.htcp, htcpInSocket6);
+    if (((struct sockaddr_in *)&Config.Addrs.udp_outgoing)->sin_addr.s_addr != no_addr.s_addr) {
 	enter_suid();
+	xmemcpy(&addr, &Config.Addrs.udp_outgoing, sizeof(addr));
+	((struct sockaddr_in *)&addr)->sin_port = htons(Config.Port.htcp);
 	htcpOutSocket = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    Config.Addrs.udp_outgoing,
-	    Config.Port.htcp,
+	    &addr,
 	    COMM_NONBLOCKING,
 	    "Outgoing HTCP Socket");
 	leave_suid();
@@ -1147,6 +1191,24 @@
     } else {
 	htcpOutSocket = htcpInSocket;
     }
+    if (!IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&Config.Addrs.udp6_outgoing)->sin6_addr) ) {
+	xmemcpy(&addr, &Config.Addrs.udp6_outgoing, sizeof(addr));
+	((struct sockaddr_in6 *)&addr)->sin6_port = htons(Config.Port.htcp);
+	htcpOutSocket6 = comm_open(SOCK_DGRAM,
+	    IPPROTO_UDP,
+	    &addr,
+	    COMM_NONBLOCKING,
+	    "Outgoing HTCP Socket");
+	leave_suid();
+	if (htcpOutSocket < 0)
+	    fatal("Cannot open Outgoing HTCP Socket");
+	commSetSelect(htcpOutSocket6, COMM_SELECT_READ, htcpRecv, NULL, 0);
+	debug(31, 1) ("Outgoing HTCP messages v6 on port %d, FD %d.\n",
+	    (int) Config.Port.htcp, htcpOutSocket6);
+	fd_note(htcpInSocket, "Incoming HTCP socket v6");
+    } else {
+	htcpOutSocket6 = htcpInSocket6;
+    }
     if (!htcpSpecifierPool) {
 	htcpSpecifierPool = memPoolCreate("htcpSpecifier", sizeof(htcpSpecifier));
 	htcpDetailPool = memPoolCreate("htcpDetail", sizeof(htcpDetail));
@@ -1215,6 +1277,10 @@
 	debug(12, 1) ("FD %d Closing HTCP socket\n", htcpInSocket);
 	comm_close(htcpInSocket);
     }
+    if (htcpInSocket6 != htcpOutSocket6) {
+	debug(12, 1) ("FD %d Closing HTCP socket v6\n", htcpInSocket6);
+	comm_close(htcpInSocket6);
+    }
     /*      
      * Here we set 'htcpInSocket' to -1 even though the HTCP 'in'
      * and 'out' sockets might be just one FD.  This prevents this
@@ -1222,6 +1288,7 @@
      * exit or restart, main will comm_close the 'out' descriptor.
      */
     htcpInSocket = -1;
+    htcpInSocket6 = -1;
     /*      
      * Normally we only write to the outgoing HTCP socket, but
      * we also have a read handler there to catch messages sent
@@ -1233,6 +1300,8 @@
      */
     assert(htcpOutSocket > -1);
     commSetSelect(htcpOutSocket, COMM_SELECT_READ, NULL, NULL, 0);
+    assert(htcpOutSocket6 > -1);
+    commSetSelect(htcpOutSocket6, COMM_SELECT_READ, NULL, NULL, 0);
 }
 
 void
@@ -1243,5 +1312,10 @@
 	debug(12, 1) ("FD %d Closing HTCP socket\n", htcpOutSocket);
 	comm_close(htcpOutSocket);
 	htcpOutSocket = -1;
+    }
+    if (htcpOutSocket6 > -1) {
+	debug(12, 1) ("FD %d Closing HTCP socket v6\n", htcpOutSocket6);
+	comm_close(htcpOutSocket6);
+	htcpOutSocket6 = -1;
     }
 }
diff -r -u squid-2.6.STABLE13/src/http.c new-STABLE13/src/http.c
--- squid-2.6.STABLE13/src/http.c	Tue Mar 27 08:08:00 2007
+++ new-STABLE13/src/http.c	Sun May 13 00:59:37 2007
@@ -628,7 +628,7 @@
     StoreEntry *entry = httpState->entry;
     const request_t *request = httpState->request;
     const request_t *orig_request = httpState->orig_request;
-    struct in_addr *client_addr = NULL;
+    struct sockaddr *client_addr = NULL;
     u_short client_port = 0;
     int fd = httpState->fd;
     int complete = httpState->eof;
@@ -804,11 +804,11 @@
 	    clientPinConnection(orig_request->pinned_connection, fd, orig_request, httpState->peer, request->flags.connection_auth);
 	} else if (httpState->peer) {
 	    if (httpState->peer->options.originserver)
-		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, httpState->orig_request->host, client_addr, client_port);
+		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, httpState->orig_request->host, client_addr);
 	    else
-		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, NULL, client_addr, client_port);
+		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, NULL, client_addr);
 	} else {
-	    pconnPush(fd, request->host, request->port, NULL, client_addr, client_port);
+	    pconnPush(fd, request->host, request->port, NULL, client_addr);
 	}
 	fwdComplete(httpState->fwd);
 	httpState->fd = -1;
@@ -1212,10 +1212,23 @@
     }
     /* append X-Forwarded-For */
     if (opt_forwarded_for) {
+	int known_addr = 0;
 	strFwd = httpHeaderGetList(hdr_in, HDR_X_FORWARDED_FOR);
+	if ((orig_request->client_addr.ss_family == AF_INET) &&
+	    (((struct sockaddr_in *)&orig_request->client_addr)->sin_addr.s_addr != no_addr.s_addr) ) {
 	strListAdd(&strFwd,
-	    (((orig_request->client_addr.s_addr != no_addr.s_addr) && opt_forwarded_for) ?
-		inet_ntoa(orig_request->client_addr) : "unknown"), ',');
+		sockaddr_ntoa(&orig_request->client_addr), ',');
+	known_addr = 1;
+	}
+	if ((orig_request->client_addr.ss_family == AF_INET6) &&
+	    !IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&orig_request->client_addr)->sin6_addr)) {
+	strListAdd(&strFwd,
+		sockaddr_ntoa(&orig_request->client_addr), ',');
+	known_addr = 1;
+	}
+	if (!known_addr)
+	    strListAdd(&strFwd, "unknown" , ',');
+
 	httpHeaderPutStr(hdr_out, HDR_X_FORWARDED_FOR, strBuf(strFwd));
 	stringClean(&strFwd);
     }
@@ -1540,7 +1553,7 @@
 	if (httpState->reply_hdr_state >= 2 && !httpState->flags.abuse_detected) {
 	    httpState->flags.abuse_detected = 1;
 	    debug(11, 1) ("httpSendRequestEntryDone: Likely proxy abuse detected '%s' -> '%s'\n",
-		inet_ntoa(httpState->orig_request->client_addr),
+		sockaddr_ntoa(&httpState->orig_request->client_addr),
 		storeUrl(httpState->entry));
 	    if (httpState->entry->mem_obj->reply->sline.status == HTTP_INVALID_HEADER) {
 		memFree8K(buf);
diff -r -u squid-2.6.STABLE13/src/icp_v2.c new-STABLE13/src/icp_v2.c
--- squid-2.6.STABLE13/src/icp_v2.c	Mon Jun 26 00:53:14 2006
+++ new-STABLE13/src/icp_v2.c	Sun May 13 00:59:37 2007
@@ -35,8 +35,8 @@
 
 #include "squid.h"
 
-static void icpLogIcp(struct in_addr, log_type, int, const char *, int);
-static void icpHandleIcpV2(int, struct sockaddr_in, char *, int);
+static void icpLogIcp(struct sockaddr *, log_type, int, const char *, int);
+static void icpHandleIcpV2(int, struct sockaddr *, char *, int);
 static void icpCount(void *, int, size_t, int);
 
 /*
@@ -46,7 +46,7 @@
 static icpUdpData *IcpQueueTail = NULL;
 
 static void
-icpLogIcp(struct in_addr caddr, log_type logcode, int len, const char *url, int delay)
+icpLogIcp(struct sockaddr *caddr, log_type logcode, int len, const char *url, int delay)
 {
     AccessLogEntry al;
     if (LOG_TAG_NONE == logcode)
@@ -59,7 +59,7 @@
     memset(&al, '\0', sizeof(al));
     al.icp.opcode = ICP_QUERY;
     al.url = url;
-    al.cache.caddr = caddr;
+    xmemcpy(&al.cache.caddr, caddr, SOCKLEN(caddr));
     al.cache.size = len;
     al.cache.code = logcode;
     al.cache.msec = delay;
@@ -106,7 +106,7 @@
     headerp->reqnum = htonl(reqnum);
     headerp->flags = htonl(flags);
     headerp->pad = htonl(pad);
-    headerp->shostid = theOutICPAddr.s_addr;
+    xmemcpy(&headerp->shostid, &theOutICPAddr, sizeof(struct sockaddr_storage));
     urloffset = buf + sizeof(icp_common_t);
     if (opcode == ICP_QUERY)
 	urloffset += sizeof(u_num32);
@@ -116,7 +116,7 @@
 
 int
 icpUdpSend(int fd,
-    const struct sockaddr_in *to,
+    const struct sockaddr *to,
     icp_common_t * msg,
     log_type logcode,
     int delay)
@@ -124,23 +124,25 @@
     icpUdpData *queue;
     int x;
     int len;
+    char host[100], port[8];
     len = (int) ntohs(msg->length);
-    debug(12, 5) ("icpUdpSend: FD %d sending %s, %d bytes to %s:%d\n",
+    getnameinfo(to, SOCKLEN(to), host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
+    debug(12, 5) ("icpUdpSend: FD %d sending %s, %d bytes to %s:%s\n",
 	fd,
 	icp_opcode_str[msg->opcode],
 	len,
-	inet_ntoa(to->sin_addr),
-	ntohs(to->sin_port));
-    x = comm_udp_sendto(fd, to, sizeof(*to), msg, len);
+	host,
+	port);
+    x = comm_udp_sendto(fd, to, SOCKLEN(to), msg, len);
     if (x >= 0) {
 	/* successfully written */
-	icpLogIcp(to->sin_addr, logcode, len, (char *) (msg + 1), delay);
+	icpLogIcp(to, logcode, len, (char *) (msg + 1), delay);
 	icpCount(msg, SENT, (size_t) len, delay);
 	safe_free(msg);
     } else if (0 == delay) {
 	/* send failed, but queue it */
 	queue = xcalloc(1, sizeof(icpUdpData));
-	queue->address = *to;
+	xmemcpy(&queue->address, to, SOCKLEN(to));
 	queue->msg = msg;
 	queue->len = (int) ntohs(msg->length);
 	queue->queue_time = current_time;
@@ -179,7 +181,7 @@
 }
 
 static void
-icpHandleIcpV2(int fd, struct sockaddr_in from, char *buf, int len)
+icpHandleIcpV2(int fd, struct sockaddr *from, char *buf, int len)
 {
     icp_common_t header;
     StoreEntry *entry = NULL;
@@ -224,22 +226,23 @@
 	    break;
 	}
 	memset(&checklist, '\0', sizeof(checklist));
-	checklist.src_addr = from.sin_addr;
-	checklist.my_addr = no_addr;
+	xmemcpy(&checklist.src_addr, from, SOCKLEN(from));
+	memset(&checklist.my_addr, 0, sizeof(checklist.my_addr));
+	checklist.my_addr.ss_family = checklist.src_addr.ss_family;
 	checklist.request = icp_request;
 	allow = aclCheckFast(Config.accessList.icp, &checklist);
 	if (!allow) {
 	    debug(12, 2) ("icpHandleIcpV2: Access Denied for %s by %s.\n",
-		inet_ntoa(from.sin_addr), AclMatchedName);
-	    if (clientdbCutoffDenied(from.sin_addr)) {
+		sockaddr_ntoa(from), AclMatchedName);
+	    if (clientdbCutoffDenied(from)) {
 		/*
 		 * count this DENIED query in the clientdb, even though
 		 * we're not sending an ICP reply...
 		 */
-		clientdbUpdate(from.sin_addr, LOG_UDP_DENIED, PROTO_ICP, 0);
+		clientdbUpdate(from, LOG_UDP_DENIED, PROTO_ICP, 0);
 	    } else {
 		reply = icpCreateMessage(ICP_DENIED, 0, url, header.reqnum, 0);
-		icpUdpSend(fd, &from, reply, LOG_UDP_DENIED, 0);
+		icpUdpSend(fd, from, reply, LOG_UDP_DENIED, 0);
 	    }
 	    break;
 	}
@@ -255,7 +258,7 @@
 	debug(12, 5) ("icpHandleIcpV2: OPCODE %s\n", icp_opcode_str[header.opcode]);
 	if (icpCheckUdpHit(entry, icp_request)) {
 	    reply = icpCreateMessage(ICP_HIT, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_HIT, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_HIT, 0);
 	    break;
 	}
 	if (Config.onoff.test_reachability && rtt == 0) {
@@ -265,16 +268,16 @@
 	/* if store is rebuilding, return a UDP_HIT, but not a MISS */
 	if (store_dirs_rebuilding && opt_reload_hit_only) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else if (hit_only_mode_until > squid_curtime) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else if (Config.onoff.test_reachability && rtt == 0) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else {
 	    reply = icpCreateMessage(ICP_MISS, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_MISS, 0);
 	}
 	break;
 
@@ -288,18 +291,18 @@
     case ICP_MISS_NOFETCH:
 	if (neighbors_do_private_keys && header.reqnum == 0) {
 	    debug(12, 0) ("icpHandleIcpV2: Neighbor %s returned reqnum = 0\n",
-		inet_ntoa(from.sin_addr));
+		sockaddr_ntoa(from));
 	    debug(12, 0) ("icpHandleIcpV2: Disabling use of private keys\n");
 	    neighbors_do_private_keys = 0;
 	}
 	url = buf + sizeof(icp_common_t);
 	debug(12, 3) ("icpHandleIcpV2: %s from %s for '%s'\n",
 	    icp_opcode_str[header.opcode],
-	    inet_ntoa(from.sin_addr),
+	    sockaddr_ntoa(from),
 	    url);
 	key = icpGetCacheKey(url, (int) header.reqnum);
 	/* call neighborsUdpAck even if ping_status != PING_WAITING */
-	neighborsUdpAck(key, &header, &from);
+	neighborsUdpAck(key, &header, from);
 	break;
 
     case ICP_INVALID:
@@ -308,7 +311,7 @@
 
     default:
 	debug(12, 0) ("icpHandleIcpV2: UNKNOWN OPCODE: %d from %s\n",
-	    header.opcode, inet_ntoa(from.sin_addr));
+	    header.opcode, sockaddr_ntoa(from));
 	break;
     }
     if (icp_request)
@@ -338,7 +341,7 @@
 icpHandleUdp(int sock, void *data)
 {
     int *N = &incoming_sockets_accepted;
-    struct sockaddr_in from;
+    struct sockaddr_storage from;
     socklen_t from_len;
     LOCAL_ARRAY(char, buf, SQUID_UDP_SO_RCVBUF);
     int len;
@@ -377,7 +380,7 @@
 	debug(12, 4) ("icpHandleUdp: FD %d: received %d bytes from %s.\n",
 	    sock,
 	    len,
-	    inet_ntoa(from.sin_addr));
+	    sockaddr_ntoa((struct sockaddr *)&from));
 #ifdef ICP_PACKET_DUMP
 	icpPktDump(buf);
 #endif
@@ -387,14 +390,17 @@
 	}
 	icp_version = (int) buf[1];	/* cheat! */
 	if (icp_version == ICP_VERSION_2)
-	    icpHandleIcpV2(sock, from, buf, len);
+	    icpHandleIcpV2(sock, &from, buf, len);
 	else if (icp_version == ICP_VERSION_3)
-	    icpHandleIcpV3(sock, from, buf, len);
+	    icpHandleIcpV3(sock, &from, buf, len);
 	else
 	    debug(12, 1) ("WARNING: Unused ICP version %d received from %s:%d\n",
 		icp_version,
-		inet_ntoa(from.sin_addr),
-		ntohs(from.sin_port));
+		sockaddr_ntoa((struct sockaddr *)&from),
+		from.ss_family == AF_INET6 ? 
+		    ntohs(((struct sockaddr_in6 *)&from)->sin6_port) :
+		    ntohs(((struct sockaddr_in *)&from)->sin_port) 
+		);
     }
 }
 
@@ -402,20 +408,28 @@
 icpConnectionsOpen(void)
 {
     u_short port;
-    struct in_addr addr;
-    struct sockaddr_in xaddr;
+    struct sockaddr_storage addr;
+    struct sockaddr_storage xaddr;
     int x;
     socklen_t len;
     wordlist *s;
     if ((port = Config.Port.icp) <= 0)
 	return;
     enter_suid();
+    xmemcpy(&addr, &Config.Addrs.udp_incoming, sizeof(addr));
+    ((struct sockaddr_in *)&addr)->sin_port = htons(port);
     theInIcpConnection = comm_open(SOCK_DGRAM,
 	IPPROTO_UDP,
-	Config.Addrs.udp_incoming,
-	port,
+	&addr,
 	COMM_NONBLOCKING,
 	"ICP Socket");
+    xmemcpy(&addr, &Config.Addrs.udp6_incoming, sizeof(addr));
+    ((struct sockaddr_in6 *)&addr)->sin6_port = htons(port);
+    theInIcpConnection6 = comm_open(SOCK_DGRAM,
+	IPPROTO_UDP,
+	&addr,
+	COMM_NONBLOCKING,
+	"ICP Socket v6");
     leave_suid();
     if (theInIcpConnection < 0)
 	fatal("Cannot open ICP Port");
@@ -424,17 +438,29 @@
 	icpHandleUdp,
 	NULL,
 	0);
+    if (theInIcpConnection6 < 0)
+	fatal("Cannot open ICP Port v6");
+    commSetSelect(theInIcpConnection6,
+	COMM_SELECT_READ,
+	icpHandleUdp,
+	NULL,
+	0);
     for (s = Config.mcast_group_list; s; s = s->next)
 	ipcache_nbgethostbyname(s->key, mcastJoinGroups, NULL);
     debug(12, 1) ("Accepting ICP messages at %s, port %d, FD %d.\n",
-	inet_ntoa(Config.Addrs.udp_incoming),
+	sockaddr_ntoa((struct sockaddr *)&Config.Addrs.udp_incoming),
 	(int) port, theInIcpConnection);
-    if ((addr = Config.Addrs.udp_outgoing).s_addr != no_addr.s_addr) {
+    debug(12, 1) ("Accepting ICP messages v6 at %s, port %d, FD %d.\n",
+	sockaddr_ntoa((struct sockaddr *)&Config.Addrs.udp6_incoming),
+	(int) port, theInIcpConnection6);
+
+    if (((struct sockaddr_in *)&Config.Addrs.udp_outgoing)->sin_addr.s_addr != no_addr.s_addr) {
+	xmemcpy(&addr, &Config.Addrs.udp_outgoing, sizeof(addr));
+	((struct sockaddr_in *)&addr)->sin_port = htons(port);
 	enter_suid();
 	theOutIcpConnection = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    addr,
-	    port,
+	    &addr,
 	    COMM_NONBLOCKING,
 	    "ICP Port");
 	leave_suid();
@@ -452,8 +478,33 @@
     } else {
 	theOutIcpConnection = theInIcpConnection;
     }
-    memset(&theOutICPAddr, '\0', sizeof(struct in_addr));
-    len = sizeof(struct sockaddr_in);
+    if (!IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&Config.Addrs.udp6_outgoing)->sin6_addr) ) {
+	xmemcpy(&addr, &Config.Addrs.udp6_outgoing, sizeof(addr));
+	((struct sockaddr_in6 *)&addr)->sin6_port = htons(port);
+	enter_suid();
+	theOutIcpConnection6 = comm_open(SOCK_DGRAM,
+	    IPPROTO_UDP,
+	    &addr,
+	    COMM_NONBLOCKING,
+	    "ICP Port v6");
+	leave_suid();
+	if (theOutIcpConnection6 < 0)
+	    fatal("Cannot open Outgoing ICP Port v6");
+	commSetSelect(theOutIcpConnection6,
+	    COMM_SELECT_READ,
+	    icpHandleUdp,
+	    NULL,
+	    0);
+	debug(12, 1) ("Outgoing ICP messages v6 on port %d, FD %d.\n",
+	    (int) port, theOutIcpConnection6);
+	fd_note(theOutIcpConnection6, "Outgoing ICP socket v6");
+	fd_note(theInIcpConnection6, "Incoming ICP socket v6");
+    } else {
+	theOutIcpConnection6 = theInIcpConnection6;
+    }
+
+    memset(&theOutICPAddr, '\0', sizeof(struct sockaddr_storage));
+    len = sizeof(struct sockaddr_storage);
     memset(&xaddr, '\0', len);
     x = getsockname(theOutIcpConnection,
 	(struct sockaddr *) &xaddr, &len);
@@ -461,7 +512,18 @@
 	debug(12, 1) ("theOutIcpConnection FD %d: getsockname: %s\n",
 	    theOutIcpConnection, xstrerror());
     else
-	theOutICPAddr = xaddr.sin_addr;
+	xmemcpy(&theOutICPAddr, &xaddr, sizeof(xaddr));
+
+    memset(&theOutICPAddr6, '\0', sizeof(struct sockaddr_storage));
+    len = sizeof(struct sockaddr_storage);
+    memset(&xaddr, '\0', len);
+    x = getsockname(theOutIcpConnection6,
+	(struct sockaddr *) &xaddr, &len);
+    if (x < 0)
+	debug(12, 1) ("theOutIcpConnection6 FD %d: getsockname: %s\n",
+	    theOutIcpConnection6, xstrerror());
+    else
+	xmemcpy(&theOutICPAddr6, &xaddr, sizeof(xaddr));
 }
 
 /*
@@ -471,12 +533,16 @@
 void
 icpConnectionShutdown(void)
 {
-    if (theInIcpConnection < 0)
+    if (theInIcpConnection < 0 && theInIcpConnection6 < 0)
 	return;
-    if (theInIcpConnection != theOutIcpConnection) {
+    if (theInIcpConnection > 0 && theInIcpConnection != theOutIcpConnection) {
 	debug(12, 1) ("FD %d Closing ICP connection\n", theInIcpConnection);
 	comm_close(theInIcpConnection);
     }
+    if (theInIcpConnection6> 0 && theInIcpConnection6!=theOutIcpConnection6) {
+	debug(12, 1) ("FD %d Closing ICP connection6\n", theInIcpConnection6);
+	comm_close(theInIcpConnection6);
+    }
     /*
      * Here we set 'theInIcpConnection' to -1 even though the ICP 'in'
      * and 'out' sockets might be just one FD.  This prevents this
@@ -484,6 +550,7 @@
      * exit or restart, main will comm_close the 'out' descriptor.
      */
     theInIcpConnection = -1;
+    theInIcpConnection6 = -1;
     /*
      * Normally we only write to the outgoing ICP socket, but
      * we also have a read handler there to catch messages sent
@@ -491,7 +558,9 @@
      * disable reading on the outgoing socket.
      */
     assert(theOutIcpConnection > -1);
+    assert(theOutIcpConnection6 > -1);
     commSetSelect(theOutIcpConnection, COMM_SELECT_READ, NULL, NULL, 0);
+    commSetSelect(theOutIcpConnection6, COMM_SELECT_READ, NULL, NULL, 0);
 }
 
 void
@@ -502,6 +571,11 @@
 	debug(12, 1) ("FD %d Closing ICP connection\n", theOutIcpConnection);
 	comm_close(theOutIcpConnection);
 	theOutIcpConnection = -1;
+    }
+    if (theOutIcpConnection6 > -1) {
+	debug(12, 1) ("FD %d Closing ICP connection\n", theOutIcpConnection6);
+	comm_close(theOutIcpConnection6);
+	theOutIcpConnection6 = -1;
     }
 }
 
